/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package vista;

import controller.Validaciones;
import controller.dao.PersonaDao;
import javax.swing.JOptionPane;
import vistas.modelo.ModeloTablaAdministrador;

/**
 *
 * @author Mary Salazar
 */
public class Frm_Administrador extends javax.swing.JFrame {

    PersonaDao adimDao = new PersonaDao();
    private ModeloTablaAdministrador modelo = new ModeloTablaAdministrador();
    Validaciones validar = new Validaciones();

    /**
     * Creates new form Frm_Persona
     */
    public Frm_Administrador() {
        initComponents();
        this.setLocationRelativeTo(null);
        txtAdminQuemado.setEnabled(false);
        cargarTabla();
    }

    private void cargarTabla() {
        try {
            modelo.setLista(adimDao.getListado());
            tablaAdministrador.setModel(modelo);
            tablaAdministrador.updateUI();
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null, "Error al Cargar la Tabla");
        }
    }

    public void Limpiar() {
        txtnombre.setText(null);
        txtcedula.setText(null);
        txtapellido.setText(null);
        txtdireccion.setText(null);
        txtcorreo.setText(null);
        txtcelular.setText(null);
        txtusuario2.setText(null);
        txtcontra.setText(null);
    }

    public void verficarGuardar() {
        if (comprobarCedula()) {
            if (comprobarUsuario()) {
                guardarAdministrador();
            } else {
                JOptionPane.showMessageDialog(null, "El USUARIO NO SE ENCUENTRA DISPONIBLE");
            }
        } else {
            JOptionPane.showMessageDialog(null, "LA CEDULA INGRESADA, YA EXISTE EN EL SISTEMA");
        }

    }

    public void guardarAdministrador() {
        if (txtcedula.getText().equals("") || txtapellido.getText().equals("") || txtnombre.getText().equals("")
                || txtcelular.getText().equals("") || txtdireccion.getText().equals("")
                || cboGenero.getSelectedItem().equals("Seleccione") || txtusuario2.getText().equals("") || txtcontra.getText().equals("")) {
            JOptionPane.showMessageDialog(this, "LLene todos los campos");

        } else {
            adimDao.setPersona(null);
            adimDao.getPersona().setCedula(txtcedula.getText());
            adimDao.getPersona().setNombre(txtnombre.getText());
            adimDao.getPersona().setApellido(txtapellido.getText());
            adimDao.getPersona().setCelular(txtcelular.getText());
            adimDao.getPersona().setCorreo(txtcorreo.getText());
            adimDao.getPersona().setDireccion(txtdireccion.getText());
            adimDao.getPersona().setSexo(cboGenero.getSelectedItem().toString());
            adimDao.getPersona().setRol(txtAdminQuemado.getText());
            adimDao.getPersona().getCuenta().setUsuario(txtusuario2.getText());
            adimDao.getPersona().getCuenta().setClave(txtcontra.getText());

            if (adimDao.getPersona().getId() == null) {
                if (adimDao.guardar()) {
                    JOptionPane.showMessageDialog(this, "Se ha registrado correctamente");
                    Limpiar();
                    cargarTabla();
                } else {
                    JOptionPane.showMessageDialog(this, "No registrado");
                }
            }
        }
    }

    public boolean comprobarCedula() {
        boolean f = true;
        adimDao.getListado();
        String valor = txtcedula.getText();
        String usuario = txtusuario2.getText();
        try {
            for (int i = 0; i < adimDao.getListado().tamanio(); i++) {
                if (adimDao.getListado().consultarDatoPos(i).getCedula().equals(valor)
                        && adimDao.getListado().consultarDatoPos(i).getCuenta().getUsuario().equals(valor)) {
                    f = false;
                }
            }
        } catch (Exception e) {

        }
        return f;
    }

    public boolean comprobarUsuario() {
        boolean f = true;
        adimDao.getListado();
        String usuario = txtusuario2.getText();
        try {
            for (int i = 0; i < adimDao.getListado().tamanio(); i++) {
                if (adimDao.getListado().consultarDatoPos(i).getCuenta().getUsuario().equals(usuario)) {
                    f = false;
                }
            }
        } catch (Exception e) {

        }
        return f;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTable2 = new javax.swing.JTable();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        txtapellido = new javax.swing.JTextField();
        txtnombre = new javax.swing.JTextField();
        txtcedula = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        cboGenero = new javax.swing.JComboBox<>();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        txtcelular = new javax.swing.JTextField();
        txtcorreo = new javax.swing.JTextField();
        jLabel14 = new javax.swing.JLabel();
        jTextField9 = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        btnGuardar = new javax.swing.JButton();
        btnmodificar = new javax.swing.JButton();
        btnCancelar = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        tablaAdministrador = new javax.swing.JTable();
        jLabel15 = new javax.swing.JLabel();
        jLabel17 = new javax.swing.JLabel();
        txtdireccion = new javax.swing.JTextField();
        txtAdminQuemado = new javax.swing.JTextField();
        jLabel16 = new javax.swing.JLabel();
        jLabel18 = new javax.swing.JLabel();
        txtcontra = new javax.swing.JPasswordField();
        txtusuario2 = new javax.swing.JTextField();

        jTable1.setBorder(javax.swing.BorderFactory.createTitledBorder("LIstado de Pacientes Registrados"));
        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(jTable1);

        jTable2.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane2.setViewportView(jTable2);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jPanel1.setBackground(new java.awt.Color(130, 161, 177));
        jPanel1.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 36)); // NOI18N
        jLabel1.setForeground(new java.awt.Color(255, 255, 255));
        jLabel1.setText("Registro Administrador ");
        jPanel1.add(jLabel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(120, 0, 470, 60));

        jLabel2.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabel2.setText("Apellido");
        jPanel1.add(jLabel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 270, -1, 30));

        jLabel3.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabel3.setText("Nombre");
        jPanel1.add(jLabel3, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 310, -1, 30));

        jLabel4.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabel4.setText("Cédula");
        jPanel1.add(jLabel4, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 230, -1, 30));

        txtapellido.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                txtapellidoKeyTyped(evt);
            }
        });
        jPanel1.add(txtapellido, new org.netbeans.lib.awtextra.AbsoluteConstraints(100, 270, 200, 30));

        txtnombre.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                txtnombreKeyTyped(evt);
            }
        });
        jPanel1.add(txtnombre, new org.netbeans.lib.awtextra.AbsoluteConstraints(100, 310, 200, 30));

        txtcedula.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtcedulaActionPerformed(evt);
            }
        });
        txtcedula.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                txtcedulaKeyTyped(evt);
            }
        });
        jPanel1.add(txtcedula, new org.netbeans.lib.awtextra.AbsoluteConstraints(100, 230, 200, 30));

        jLabel7.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabel7.setText("Dirección");
        jPanel1.add(jLabel7, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 350, 70, 30));

        jLabel8.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabel8.setText("Género");
        jPanel1.add(jLabel8, new org.netbeans.lib.awtextra.AbsoluteConstraints(330, 280, -1, -1));

        cboGenero.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        cboGenero.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Seleccione", "Masculino", "Femenino" }));
        jPanel1.add(cboGenero, new org.netbeans.lib.awtextra.AbsoluteConstraints(490, 270, 160, 30));

        jLabel9.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabel9.setText("Celular");
        jPanel1.add(jLabel9, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 400, -1, -1));

        jLabel10.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabel10.setText("Correo Electronico");
        jPanel1.add(jLabel10, new org.netbeans.lib.awtextra.AbsoluteConstraints(330, 240, -1, 20));

        txtcelular.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                txtcelularKeyTyped(evt);
            }
        });
        jPanel1.add(txtcelular, new org.netbeans.lib.awtextra.AbsoluteConstraints(100, 390, 200, 30));

        txtcorreo.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                txtcorreoKeyTyped(evt);
            }
        });
        jPanel1.add(txtcorreo, new org.netbeans.lib.awtextra.AbsoluteConstraints(490, 230, 160, 30));

        jLabel14.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabel14.setText("Cedula");
        jPanel1.add(jLabel14, new org.netbeans.lib.awtextra.AbsoluteConstraints(40, 160, -1, 30));
        jPanel1.add(jTextField9, new org.netbeans.lib.awtextra.AbsoluteConstraints(160, 160, 200, 30));

        jButton1.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jButton1.setText("Buscar");
        jPanel1.add(jButton1, new org.netbeans.lib.awtextra.AbsoluteConstraints(400, 160, 90, 30));

        btnGuardar.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        btnGuardar.setText("Registrar");
        btnGuardar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnGuardarActionPerformed(evt);
            }
        });
        jPanel1.add(btnGuardar, new org.netbeans.lib.awtextra.AbsoluteConstraints(60, 450, 100, 30));

        btnmodificar.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        btnmodificar.setText("Modificar");
        jPanel1.add(btnmodificar, new org.netbeans.lib.awtextra.AbsoluteConstraints(270, 450, 100, 30));

        btnCancelar.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        btnCancelar.setText("Cancelar");
        jPanel1.add(btnCancelar, new org.netbeans.lib.awtextra.AbsoluteConstraints(520, 450, 100, 30));

        jPanel2.setBackground(new java.awt.Color(255, 255, 255));
        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "LISTADO DEL PERSONAL", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 14))); // NOI18N
        jPanel2.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        tablaAdministrador.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Cedula", "Apellido", "Nombre", "Genero", "Edad", "Correo Electronico"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false, true, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tablaAdministrador.setGridColor(new java.awt.Color(255, 255, 255));
        jScrollPane3.setViewportView(tablaAdministrador);
        if (tablaAdministrador.getColumnModel().getColumnCount() > 0) {
            tablaAdministrador.getColumnModel().getColumn(0).setResizable(false);
            tablaAdministrador.getColumnModel().getColumn(1).setResizable(false);
            tablaAdministrador.getColumnModel().getColumn(2).setResizable(false);
            tablaAdministrador.getColumnModel().getColumn(3).setResizable(false);
            tablaAdministrador.getColumnModel().getColumn(4).setResizable(false);
            tablaAdministrador.getColumnModel().getColumn(5).setResizable(false);
        }

        jPanel2.add(jScrollPane3, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 30, 590, 100));

        jPanel1.add(jPanel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 500, 630, 150));

        jLabel15.setIcon(new javax.swing.ImageIcon(getClass().getResource("/img/google_forms_96px.png"))); // NOI18N
        jPanel1.add(jLabel15, new org.netbeans.lib.awtextra.AbsoluteConstraints(270, 60, 90, 80));

        jLabel17.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabel17.setText("Rol");
        jPanel1.add(jLabel17, new org.netbeans.lib.awtextra.AbsoluteConstraints(330, 310, -1, 30));

        txtdireccion.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                txtdireccionKeyTyped(evt);
            }
        });
        jPanel1.add(txtdireccion, new org.netbeans.lib.awtextra.AbsoluteConstraints(100, 350, 200, 30));

        txtAdminQuemado.setText("ADMINISTRADOR");
        jPanel1.add(txtAdminQuemado, new org.netbeans.lib.awtextra.AbsoluteConstraints(490, 320, 160, 30));

        jLabel16.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabel16.setText("Usuario");
        jPanel1.add(jLabel16, new org.netbeans.lib.awtextra.AbsoluteConstraints(330, 360, -1, 30));

        jLabel18.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabel18.setText("Contraseña");
        jPanel1.add(jLabel18, new org.netbeans.lib.awtextra.AbsoluteConstraints(330, 400, -1, 30));

        txtcontra.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jPanel1.add(txtcontra, new org.netbeans.lib.awtextra.AbsoluteConstraints(490, 400, 160, 30));

        txtusuario2.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                txtusuario2KeyTyped(evt);
            }
        });
        jPanel1.add(txtusuario2, new org.netbeans.lib.awtextra.AbsoluteConstraints(490, 360, 160, 30));

        getContentPane().add(jPanel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 680, 680));

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void btnGuardarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnGuardarActionPerformed
        // TODO add your handling code here:
        verficarGuardar();
    }//GEN-LAST:event_btnGuardarActionPerformed

    private void txtcedulaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtcedulaActionPerformed
        validar.validadorDeCedula(txtcedula.getText(), txtcedula);
    }//GEN-LAST:event_txtcedulaActionPerformed

    private void txtcedulaKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtcedulaKeyTyped
        // TODO add your handling code here:
        validar.valNum(evt, txtcedula, 10);
        validar.EnterAJtexFiel(txtapellido, evt);
    }//GEN-LAST:event_txtcedulaKeyTyped

    private void txtapellidoKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtapellidoKeyTyped
        validar.Mayusculas(txtapellido.getText(), evt);
        validar.valLetr(evt, txtapellido, 50);
        validar.EnterAJtexFiel(txtnombre, evt);
    }//GEN-LAST:event_txtapellidoKeyTyped

    private void txtnombreKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtnombreKeyTyped
        validar.Mayusculas(txtnombre.getText(), evt);
        validar.valLetr(evt, txtnombre, 30);
        validar.EnterAJtexFiel(txtdireccion, evt);
    }//GEN-LAST:event_txtnombreKeyTyped

    private void txtdireccionKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtdireccionKeyTyped
        validar.Mayusculas(txtdireccion.getText(), evt);
        validar.valLetr(evt, txtdireccion, 60);
        validar.EnterAJtexFiel(txtcelular, evt);
    }//GEN-LAST:event_txtdireccionKeyTyped

    private void txtcelularKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtcelularKeyTyped
        validar.valNum(evt, txtcelular, 10);
        validar.EnterAJtexFiel(txtcorreo, evt);
    }//GEN-LAST:event_txtcelularKeyTyped

    private void txtcorreoKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtcorreoKeyTyped
        validar.EnterAJtexFiel(txtcorreo, evt);
    }//GEN-LAST:event_txtcorreoKeyTyped

    private void txtusuario2KeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtusuario2KeyTyped
        validar.Mayusculas(txtusuario2.getText(), evt);
        validar.valLetr(evt, txtusuario2, 10);
        validar.EnterAJtexFiel(txtcontra, evt);
    }//GEN-LAST:event_txtusuario2KeyTyped

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Frm_Administrador.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Frm_Administrador.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Frm_Administrador.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Frm_Administrador.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Frm_Administrador().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancelar;
    private javax.swing.JButton btnGuardar;
    private javax.swing.JButton btnmodificar;
    private javax.swing.JComboBox<String> cboGenero;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTable jTable1;
    private javax.swing.JTable jTable2;
    private javax.swing.JTextField jTextField9;
    private javax.swing.JTable tablaAdministrador;
    private javax.swing.JTextField txtAdminQuemado;
    private javax.swing.JTextField txtapellido;
    private javax.swing.JTextField txtcedula;
    private javax.swing.JTextField txtcelular;
    private javax.swing.JPasswordField txtcontra;
    private javax.swing.JTextField txtcorreo;
    private javax.swing.JTextField txtdireccion;
    private javax.swing.JTextField txtnombre;
    private javax.swing.JTextField txtusuario2;
    // End of variables declaration//GEN-END:variables
}
